package com.hungraim.ltc.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hungraim.ltc.dao.AprEmpMapper;
import com.hungraim.ltc.dao.AprReportMapper;
import com.hungraim.ltc.dao.TaskEmpMapper;
import com.hungraim.ltc.dao.TaskMapper;
import com.hungraim.ltc.pojo.entity.eval.ChAprEmp;
import com.hungraim.ltc.pojo.entity.eval.ChAprReport;
import com.hungraim.ltc.pojo.entity.eval.ChAprTask;
import com.hungraim.ltc.pojo.entity.eval.ChAprTaskEmp;
import com.hungraim.ltc.pojo.vo.assessment.TaskDistributionVO;
import com.hungraim.ltc.pojo.vo.assessment.TaskReportVO;
import com.hungraim.ltc.service.TaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * @author czz
 */
@Service
public class TaskServiceImpl implements TaskService {

    @Autowired
    private TaskMapper taskMapper;
    @Autowired
    private AprEmpMapper aprEmpMapper;
    @Autowired
    private AprReportMapper aprReportMapper;
    @Autowired
    private TaskEmpMapper taskEmpMapper;

    @Override
    public IPage<TaskDistributionVO> taskDistributionList(String organId, String provincial, String city,
                                                          String street, String realName, String certiCode, String taskName, String taskTel,
                                                          String daysRemaining, String status, String isReturn, String area,
                                                          int pageNum, int pageSize) {
        List<String> organIds = null;
        if (StrUtil.isNotBlank(organId)) {
            organIds = Arrays.asList(organId.split(","));
        }
        return taskMapper.taskDistributionList(new Page<>(pageNum, pageSize), organIds, provincial, city,
                street, realName, certiCode, taskName, taskTel, daysRemaining, status, isReturn, area);
    }

    @Override
    public List<TaskReportVO> taskReportList() {
        return taskMapper.taskReportList();
    }

    @Override
    public List<ChAprEmp> aprEmpList() {
        return aprEmpMapper.selectList(new QueryWrapper<ChAprEmp>().eq("IS_LOCK", 0));
    }

    @Override
    public void addReport(ChAprReport chAprReport) {
        aprReportMapper.insert(chAprReport);
    }

    @Override
    public void updateReport(String reportId, Integer disableLevelId, String polNo, String remark) {
        ChAprReport chAprReport = aprReportMapper.selectById(reportId);
        chAprReport.setDisableLevelId(disableLevelId);
        chAprReport.setPolNo(polNo);
        chAprReport.setRemark(remark);
        aprReportMapper.updateById(chAprReport);
    }

    @Override
    public int allotTask(String taskId, String empId) {
        ChAprTask task = taskMapper.selectById(taskId);
        ChAprEmp emp = aprEmpMapper.selectById(empId);
        ChAprTaskEmp chAprTaskEmp = new ChAprTaskEmp();
        chAprTaskEmp.setTaskId(task.getTaskId());
        chAprTaskEmp.setEmpId(emp.getEmpId());
        chAprTaskEmp.setIsValid(0);
        chAprTaskEmp.setFcd(new Date());
        chAprTaskEmp.setAprOrganId(Integer.getInteger(task.getOrganId()));
        return taskEmpMapper.insert(chAprTaskEmp);
    }
}